ingress-nginx-helm/test/e2e/run.sh

136 lines
4.4 KiB
Bash
Raw Normal View History

2019-03-20 21:00:00 +00:00
#!/bin/bash
2019-05-14 02:31:30 +00:00
# Copyright 2019 The Kubernetes Authors.
2019-03-20 21:00:00 +00:00
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
2020-01-30 14:42:57 +00:00
KIND_LOG_LEVEL="1"
2019-05-14 02:31:30 +00:00
if ! [ -z $DEBUG ]; then
set -x
KIND_LOG_LEVEL="6"
2019-05-14 02:31:30 +00:00
fi
set -o errexit
set -o nounset
set -o pipefail
2019-03-20 21:00:00 +00:00
2020-01-30 14:42:57 +00:00
cleanup() {
if [[ "${KUBETEST_IN_DOCKER:-}" == "true" ]]; then
kind "export" logs --name ${KIND_CLUSTER_NAME} "${ARTIFACTS}/logs" || true
fi
kind delete cluster \
--verbosity=${KIND_LOG_LEVEL} \
--name ${KIND_CLUSTER_NAME}
}
trap cleanup EXIT
2019-09-05 15:46:53 +00:00
if ! command -v parallel &> /dev/null; then
if [[ "$OSTYPE" == "linux-gnu" ]]; then
echo "Parallel is not installed. Use the package manager to install it"
elif [[ "$OSTYPE" == "darwin"* ]]; then
echo "Parallel is not installed. Install it running brew install parallel"
fi
exit 1
fi
2020-02-13 00:17:26 +00:00
if ! command -v kind --version &> /dev/null; then
echo "kind is not installed. Use the package manager or visit the official site https://kind.sigs.k8s.io/"
exit 1
fi
2019-03-20 21:00:00 +00:00
DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
# Use 1.0.0-dev to make sure we use the latest configuration in the helm template
export TAG=1.0.0-dev
2019-03-20 21:00:00 +00:00
export ARCH=amd64
2019-05-14 02:31:30 +00:00
export REGISTRY=ingress-controller
2019-03-20 21:00:00 +00:00
2020-04-04 19:22:31 +00:00
export K8S_VERSION=${K8S_VERSION:-v1.18.0@sha256:0e20578828edd939d25eb98496a685c76c98d54084932f76069f886ec315d694}
export DOCKER_CLI_EXPERIMENTAL=enabled
2019-03-20 21:00:00 +00:00
KIND_CLUSTER_NAME="ingress-nginx-dev"
2019-05-14 02:31:30 +00:00
echo "[dev-env] creating Kubernetes cluster with kind"
export KUBECONFIG="${HOME}/.kube/kind-config-${KIND_CLUSTER_NAME}"
kind create cluster \
--verbosity=${KIND_LOG_LEVEL} \
--name ${KIND_CLUSTER_NAME} \
--config ${DIR}/kind.yaml \
2020-01-30 14:42:57 +00:00
--retain \
2019-09-03 20:46:43 +00:00
--image "kindest/node:${K8S_VERSION}"
2019-03-20 21:00:00 +00:00
echo "Kubernetes cluster:"
kubectl get nodes -o wide
echo "[dev-env] building container"
2020-02-24 17:41:02 +00:00
export EXIT_CODE=-1
2019-09-05 15:46:53 +00:00
echo "
2019-03-20 21:00:00 +00:00
make -C ${DIR}/../../ build container
make -C ${DIR}/../../ e2e-test-image
2020-02-24 17:41:02 +00:00
make -C ${DIR}/../../images/fastcgi-helloserver/ GO111MODULE=\"on\" build container
make -C ${DIR}/../../images/echo/ container
make -C ${DIR}/../../images/httpbin/ container
make -C ${DIR}/../../images/cfssl/ container
2020-02-24 17:41:02 +00:00
" | parallel --joblog /tmp/log {} || EXIT_CODE=$?
2020-04-04 19:22:31 +00:00
if [ ${EXIT_CODE} -eq 0 ] || [ ${EXIT_CODE} -eq -1 ];
2020-02-24 17:41:02 +00:00
then
echo "Image builds were ok! Log:"
cat /tmp/log
unset EXIT_CODE
else
echo "Image builds were not ok! Log:"
cat /tmp/log
exit
fi
# Remove after https://github.com/kubernetes/ingress-nginx/pull/4271 is merged
docker tag ${REGISTRY}/nginx-ingress-controller-${ARCH}:${TAG} ${REGISTRY}/nginx-ingress-controller:${TAG}
2019-09-05 15:46:53 +00:00
# Preload images used in e2e tests
docker pull openresty/openresty:1.15.8.2-alpine
2020-02-24 17:41:02 +00:00
docker pull moul/grpcbin
2019-09-05 15:46:53 +00:00
KIND_WORKERS=$(kind get nodes --name="${KIND_CLUSTER_NAME}" | grep worker | awk '{printf (NR>1?",":"") $1}')
2019-05-14 02:31:30 +00:00
echo "[dev-env] copying docker images to cluster..."
2020-02-24 17:41:02 +00:00
export EXIT_CODE=-1
2019-09-05 15:46:53 +00:00
echo "
kind load docker-image --name="${KIND_CLUSTER_NAME}" --nodes=${KIND_WORKERS} nginx-ingress-controller:e2e
kind load docker-image --name="${KIND_CLUSTER_NAME}" --nodes=${KIND_WORKERS} ${REGISTRY}/nginx-ingress-controller:${TAG}
kind load docker-image --name="${KIND_CLUSTER_NAME}" --nodes=${KIND_WORKERS} ${REGISTRY}/fastcgi-helloserver:${TAG}
kind load docker-image --name="${KIND_CLUSTER_NAME}" --nodes=${KIND_WORKERS} openresty/openresty:1.15.8.2-alpine
kind load docker-image --name="${KIND_CLUSTER_NAME}" --nodes=${KIND_WORKERS} ${REGISTRY}/httpbin:${TAG}
kind load docker-image --name="${KIND_CLUSTER_NAME}" --nodes=${KIND_WORKERS} ${REGISTRY}/echo:${TAG}
kind load docker-image --name="${KIND_CLUSTER_NAME}" --nodes=${KIND_WORKERS} moul/grpcbin
kind load docker-image --name="${KIND_CLUSTER_NAME}" --nodes=${KIND_WORKERS} ${REGISTRY}/cfssl:${TAG}
2020-02-24 17:41:02 +00:00
" | parallel --joblog /tmp/log {} || EXIT_CODE=$?
2020-04-04 19:22:31 +00:00
if [ ${EXIT_CODE} -eq 0 ] || [ ${EXIT_CODE} -eq -1 ];
2020-02-24 17:41:02 +00:00
then
echo "Image loads were ok! Log:"
cat /tmp/log
unset EXIT_CODE
else
echo "Image loads were not ok! Log:"
cat /tmp/log
exit
fi
2019-05-14 02:31:30 +00:00
echo "[dev-env] running e2e tests..."
2019-03-20 21:00:00 +00:00
make -C ${DIR}/../../ e2e-test